Description

Problem
RootlineUtility ::enrichWithRelationFields does not consider the TCA setting foreign_sorting.

Hence it is not possible to retrieve media elements of pages via typoscript in the correct order.

Example
Add two images as media to a page in BE.

Use this Typoscript snippet:

page.15 = COA
page.15 {
  20 = IMG_RESOURCE
  20.stdWrap.wrap = <div><img src="|" /></div>
  20.file {
    import.data = levelmedia: -1
    import.listNum = 0
    treatIdAsReference = 1
  }
  30 = IMG_RESOURCE
  30.stdWrap.wrap = <div><img src="|" /></div>
  30.file {
    import.data = levelmedia: -1
    import.listNum = 1
    treatIdAsReference = 1
  }
}

Before the patch the images will always have the same display order, no matter how you sort them in the page properties.

Related issues:
related to Core - Bug # 46383: levelmedia ignores sorting of media records Resolved 2013-03-17
duplicated by Core - Bug # 54913: Sorting of media elements in page->resource... Closed 2014-01-11

Associated revisions
Revision f5e6ed3d - 2014-01-21 14:59 - Markus Klein
[BUGFIX] RootlineUtility does not consider foreign_sorting

Make sure RootlineUtility::enrichWithRelationFields() does take
the TCA setting foreign_sorting into account when fetching
foreign data for the rootline cache.

Resolves: #54884
Releases: 6.2, 6.1
Change-Id: I6f8323bd5a99f9009820332c220a5637e0930712
Reviewed-on: https://review.typo3.org/26727
Reviewed-by: Robert Wildling
Tested-by: Robert Wildling
Reviewed-by: Steffen Ritter
Reviewed-by: Georg Ringer
Tested-by: Georg Ringer
Reviewed-by: Markus Klein
Tested-by: Markus Klein

Revision ae547690 - 2014-01-21 15:00 - Markus Klein

[BUGFIX] RootlineUtility does not consider foreign_sorting

Make sure RootlineUtility::enrichWithRelationFields() does take
the TCA setting foreign_sorting into account when fetching
foreign data for the rootline cache.

Resolves: #54884
Releases: 6.2, 6.1
Change-Id: I6f8323bd5a99f9009820332c220a5637e0930712
Reviewed-on: https://review.typo3.org/26971
Reviewed-by: Markus Klein
Tested-by: Markus Klein

History
#1 - 2014-01-09 19:42 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26727

#2 - 2014-01-21 15:00 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-1 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/26971

#3 - 2014-01-21 15:30 - Markus Klein
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100
Applied in changeset commit:ae547690c036bc7b362e515a2b086831765dd0d9.

#4 - 2014-02-27 16:49 - Fritz Welter

Sorting might be fixed, but data = levelmedia:-1, slide does not only catch media from the particular page but also from LOWER pages.

home
.
.--sub1
.--sub2

when using levelmedia:-1 in home (with media selected), it also catches media from sub1 and sub2 additionally! That is incorrect.
#lib.sliderimages = COA
#lib.sliderimages {
    1.  1 = COA  
    2.  1 {    
    3.    stdWrap.required=1
    4.    stdWrap.outerWrap.cObject = TEXT
    5.    stdWrap.outerWrap.cObject.value = '|',
    6.    2 = IMG_RESOURCE  
    7.    2 {
    8.      file {
    9.        import.data = levelmedia: -1               
    10.        treatIdAsReference = 1
    11.        import.listNum = 0                            
    12.      }
    13.    }
    14.  } 
    15.  2 < .1
    16.  2.2.file.import.listNum = 1
    17.  3 < .1
    18.  3.2.file.import.listNum = 2
    19.  4 < .1
    20.  4.2.file.import.listNum = 3
    21.  5 < .1
    22.  5.2.file.import.listNum = 4

#}

#5 - 2014-02-27 23:36 - Markus Klein

Fritz please create a separate issue for that.
Please also have a look at the text formatting help here, this helps a lot for us to read the code more easily.
